﻿using System.Threading.Tasks;
using CommonBehaviors.Actions;
using Styx;
using Styx.Common;
using Styx.CommonBot;
using Styx.CommonBot.Coroutines;
using Styx.CommonBot.Routines;
using Styx.TreeSharp;
using Styx.WoWInternals.WoWObjects;
using System.Windows.Media;
using System.Collections.Generic;
using Styx.WoWInternals;
using System.Linq;
using System.Numerics;
using Styx.Pathing;

namespace RetriPaladin
{
    public class Main : CombatRoutine
    {
        public override WoWClass Class { get { return StyxWoW.Me.Specialization == WoWSpec.PaladinRetribution ? WoWClass.Paladin : WoWClass.None; } }
        public override string Name { get { return "Retribution Paladin [Pasterke]"; } }
        private static LocalPlayer Me { get { return StyxWoW.Me; } }

        public override Composite CombatBehavior { get { return new ActionRunCoroutine(ctx => CombatCoroutine()); } }
        public override Composite PreCombatBuffBehavior { get { return new ActionRunCoroutine(ctx => PreCombatCoroutine()); } }
        public override Composite PullBehavior
        {
            get
            {
                return new ActionRunCoroutine(ctx => PullRoutine());
            }
        }
        public override Composite RestBehavior
        {
            get
            {
                return new ActionRunCoroutine(ctx => RestCoroutine()); ;
            }
        }
        public override bool WantButton
        {
            get
            {
                return true;
            }
        }

        public override void OnButtonPress()
        {
            new Form1().Show();
        }


        public override CapabilityFlags SupportedCapabilities
        {
            get
            {
                return CapabilityFlags.All;
            }
        }

        #region Behaviors
        private static async Task<bool> RestCoroutine()
        {
            if (Me.IsCasting || SpellManager.GlobalCooldown || !Me.IsAlive || Me.Mounted || Me.IsOnTransport) return false;

            if (Me.HealthPercent <= 85) await SpellCastOnSelf("Flash of Light", Me);

            await CommonCoroutines.SleepForLagDuration();
            return false;
        }

        private static async Task<bool> PreCombatCoroutine()
        {
            if (Me.IsCasting || SpellManager.GlobalCooldown || !Me.IsAlive || Me.Mounted || Me.IsOnTransport) return false;

            if (!Me.HasAura("Greater Blessing of Kings")) await SpellCast("Greater Blessing of Kings", Me);

            if (!Me.HasAura("Greater Blessing of Might")) await SpellCast("Greater Blessing of Might", Me);

            if (!Me.HasAura("Greater Blessing of Wisdom")) await SpellCast("Greater Blessing of Wisdom", Me);

            await CommonCoroutines.SleepForLagDuration();
            return false;
        }

        static int addCount
        {
            get
            {
                return ObjectManager.GetObjectsOfType<WoWUnit>(true, false).
                Count(u => !u.IsDead
                && u.CanSelect
                && u.Attackable
                && u.IsFriendly
                && u.IsWithinMeleeRange);
            }
        }

        private static async Task<bool> PullRoutine()
        {
            if ((Vars.haveTarget || Me.CurrentTarget.IsDead) && (Me.CurrentTarget.Distance > 30 || !Me.CurrentTarget.InLineOfSight) && Movement.CanMove && Vars.findMeleeAttackers > 0) Me.ClearTarget();
            if (Vars.haveTarget && Me.CurrentTarget.IsWithinMeleeRange && Me.IsMoving) { Navigator.PlayerMover.MoveStop(); }
            if (Vars.haveTarget && Movement.CanFace && !Me.IsSafelyFacing(Me.CurrentTarget)) await Movement.faceTarget(Me.CurrentTarget);
            if (Vars.haveTarget && Me.CurrentTarget.Distance <= 30) await SpellCast("Judgment", Me.CurrentTarget);
            if (Vars.haveTarget && Me.CurrentTarget.IsWithinMeleeRange) await SpellCast("Crusader Strike", Me.CurrentTarget);
            if (Vars.haveTarget && Movement.CanMove && !StyxWoW.Me.CurrentTarget.IsWithinMeleeRange) await Movement.moveToTarget(Me.CurrentTarget);

            await CommonCoroutines.SleepForLagDuration();
            return true;
        }

        private static async Task<bool> CombatCoroutine()
        {
            if (Me.Mounted) return false;

            if (Me.IsCasting || SpellManager.GlobalCooldown) return false;

            if ((Vars.haveTarget || Me.CurrentTarget.IsDead) && (Me.CurrentTarget.Distance > 30 || !Me.CurrentTarget.InLineOfSight) && Movement.CanMove && Vars.findMeleeAttackers > 0) Me.ClearTarget();

            if (Vars.haveTarget && Me.CurrentTarget.IsWithinMeleeRange && Me.IsMoving) { Navigator.PlayerMover.MoveStop(); }

            if (Vars.haveTarget && Movement.CanFace && !Me.IsSafelyFacing(Me.CurrentTarget)) await Movement.faceTarget(Me.CurrentTarget);

            //healing
            if (Vars.haveTarget && !SpellManager.HasSpell("Lay on Hands") && Me.HealthPercent <= 30) await SpellCastOnSelf("Flash of Light", Me);

            if (Vars.haveTarget && Me.HasAura("Divine Shield") && StyxWoW.Me.HealthPercent < 100) await SpellCastOnSelf("Flash of Light", Me);

            if (Vars.haveTarget && !Me.HasAura("Forbearance") && Me.HealthPercent <= 20) await SpellCastOnSelf("Lay on Hands", Me);

            if (Vars.haveTarget && !Me.HasAura("Forbearance") && Me.HealthPercent <= 10) await SpellCastOnSelf("Divine Shield", Me);

            if (Vars.haveTarget && Me.HealthPercent <= 90) await SpellCastOnSelf("Shield of Vengeance", Me);

            //interrupt
            if (Vars.haveTarget && Me.CurrentTarget.IsCasting && Me.CurrentTarget.CanInterruptCurrentSpellCast) await SpellCast("Rebuke", Me.CurrentTarget);

            if (Vars.haveTarget && Me.CurrentTarget.IsCasting && !Me.CurrentTarget.CanInterruptCurrentSpellCast) await SpellCast("Hammer of Justice", Me.CurrentTarget);


            //rotation
            if (Vars.haveTarget && Me.CurrentTarget.IsWithinMeleeRange) await SpellCast("Judgment", Me.CurrentTarget);

            if (Vars.haveTarget && Me.CurrentTarget.IsWithinMeleeRange && Me.HasAura("Divine Purpose") && addCount < 2) await SpellCast("Justicar's Vengeance", Me.CurrentTarget);

            if (Vars.haveTarget && Me.CurrentTarget.IsWithinMeleeRange && addCount < 2 && Me.CurrentHolyPower >= 3) await SpellCast("Templar's Verdict", Me.CurrentTarget);

            if (Vars.haveTarget && Me.CurrentTarget.IsWithinMeleeRange && addCount >= 2 && (Me.CurrentHolyPower >= 3 || Me.HasAura("Divine Purpose"))) await SpellCast("Divine Storm", Me.CurrentTarget);

            if (Vars.haveTarget && Me.CurrentTarget.IsWithinMeleeRange && Me.HealthPercent <= 90) await SpellCast("Avenging Wrath", Me.CurrentTarget);

            if (Vars.haveTarget && Me.CurrentTarget.IsWithinMeleeRange && (Me.HasAura("Avenging Wrath") || Me.CurrentTarget.HasAura("Judgment"))) await SpellCast("Wake of Ashes", Me.CurrentTarget);

            if (Vars.haveTarget && Me.CurrentTarget.IsWithinMeleeRange) await SpellCast("Blade of Wrath", Me.CurrentTarget);

            if (Vars.haveTarget && Me.CurrentTarget.IsWithinMeleeRange) await SpellCast("Crusader Strike", Me.CurrentTarget);




            if (Vars.haveTarget && Movement.CanMove && !StyxWoW.Me.CurrentTarget.IsWithinMeleeRange) await Movement.moveToTarget(Me.CurrentTarget);

            await CommonCoroutines.SleepForLagDuration();
            return true;

        }
        #endregion

        #region Casting Tasks
        private static async Task<bool> SpellCast(string spell, WoWUnit target)
        {
            if (!SpellManager.CanCast(spell)) return false;

            if (!SpellManager.Cast(spell, target)) return false;

            Logging.Write("[Cast {0} on {1}", spell, target.SafeName);

            await CommonCoroutines.SleepForLagDuration();

            return true;
        }

        private static async Task<bool> SpellCastOnSelf(string spell, WoWUnit target)
        {
            if (!SpellManager.CanCast(spell)) return false;

            if (!SpellManager.Cast(spell, target)) return false;

            Logging.Write("Cast {0} on {1}", spell, target.SafeName);

            await CommonCoroutines.SleepForLagDuration();

            return true;
        }

        #endregion
    }

    public class Movement
    {
        public static bool CanMove { get { return Settings1.Default.movement == 0; } }
        public static bool CanFace { get { return Settings1.Default.facing == 0; } }

        public static async Task<bool> faceTarget(WoWUnit unit)
        {
            if (!Vars.haveTarget) return false;
            if (Vars.haveTarget && StyxWoW.Me.IsSafelyFacing(unit)) return false;
            unit.Face();

            await CommonCoroutines.SleepForLagDuration();
            return true;
        }

        public static async Task<bool> moveToTarget(WoWUnit unit)
        {
            if (Vars.haveTarget && StyxWoW.Me.CurrentTarget.IsWithinMeleeRange && StyxWoW.Me.CurrentTarget.InLineOfSight)
            {
                return false;
            }
            
            Navigator.MoveTo(StyxWoW.Me.CurrentTarget.Location);

            await CommonCoroutines.SleepForLagDuration();
            return true;
        }
    }
    public class Vars
    {
        public static bool haveTarget
        {
            get
            {
                return StyxWoW.Me.CurrentTarget != null
                    && StyxWoW.Me.CurrentTarget.CanSelect
                    && StyxWoW.Me.CurrentTarget.IsAlive
                    && StyxWoW.Me.CurrentTarget.Attackable;
            }
        }
        public static bool CanUseSpell(string spell)
        {
            if (!SpellManager.HasSpell(spell)) return false;
            if (SpellManager.Spells[spell].CooldownTimeLeft.Milliseconds > 0) return false;

            return false;
        }

        public static int findMeleeAttackers
        {
            get
            {
                return ObjectManager.GetObjectsOfTypeFast<WoWUnit>().Count(p => p != null
                && p.IsTargetingMeOrPet
                && p.IsWithinMeleeRange
                && StyxWoW.Me.Combat);
            }
        }
    }
}
